//#include "shadergen:/autogenConditioners.h"
//#include "../postFx.hlsl" 
//#include "../../shaderModelAutoGen.hlsl"
//#include "../../torque.hlsl"
#include "shaders/common/postFx/postFx.hlsl"
#include "shaders/common/torque.hlsl"
#include "shaders/common/shaderModel.hlsl"

TORQUE_UNIFORM_SAMPLER2D(backBuffer, 0);

//TORQUE_UNIFORM_SAMPLER2D(deferredTex, 1);
uniform float pixel_w;
uniform float pixel_h;
uniform float sizeX;
uniform float sizeY;

float4 main(PFXVertToPix IN) : TORQUE_TARGET0
{
   float2 uv = IN.uv0;
//float uv = TORQUE_DEFERRED_UNCONDITION( deferredTex, IN.uv0 );

   float3 base = float3(1.0, 0.0, 0.0);
   float dx = pixel_w * (1.0 / sizeX);
   float dy = pixel_h * (1.0 / sizeY);
   float2 coord = float2(dx*floor(IN.uv0.x/dx), dy*floor(IN.uv0.y/dy));
   base = TORQUE_TEX2D(backBuffer, coord).rgb;
   
   return float4(base, 1.0);
}