//tested on T3D 3.1 first of dx11 branch and last non-beta Torque before 4.0
//stick this in core/scripts/postFx or somewhere and exec it
//stick library folder in shaders/common/postFx

// PIXELATE - working dx11
$Pixelate::PixelWidth  = 3.0;//10.0;//yorks
$Pixelate::PixelHeight = 3.0;//10.0;//yorks
singleton ShaderData( PixelateShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/pixelateP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( PixelatePostEffect )  
{  
   isEnabled         = false;
   allowReflectPass  = false;
   //renderTime        = "PFXAfterBin";
   renderTime  = "PFXAfterDiffuse";//yorks
   //renderBin         = "GlowBin";//yorks this or ObjTranslucentBin below seem to work
   //renderBin = "ObjTranslucentBin";//yorks
   shader            = PixelateShader;
   stateBlock        = PFX_DefaultStateBlock;
   texture[0]        = "$backBuffer";
   renderPriority    = 10;
};

function PixelatePostEffect::setShaderConsts(%this)
{
   %this.setShaderConst("$pixel_w", $Pixelate::PixelWidth);
   %this.setShaderConst("$pixel_h", $Pixelate::PixelHeight);
   %this.setShaderConst("$sizeX",getWord($pref::Video::mode, 0));
   %this.setShaderConst("$sizeY",getWord($pref::Video::mode, 1));
}

// BLURRED VISION - working dx11
$BlurredVisionIntensity = 0.125;//1.0;//yorks
singleton ShaderData( BlurredVisionShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/blurredVisionP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( BlurredVisionPostEffect )  
{  
   isEnabled         = false;
   allowReflectPass  = false;
   //renderTime        = "PFXAfterBin";
   renderTime  = "PFXAfterDiffuse";//yorks
   //renderBin         = "GlowBin";//yorks this or ObjTranslucentBin below seem to work
   //renderBin = "ObjTranslucentBin";//yorks
   shader            = BlurredVisionShader;
   stateBlock        = PFX_DefaultStateBlock;
   texture[0]        = "$backBuffer";
   //target = "$backBuffer";//yorks
   renderPriority    = 10;
};

function BlurredVisionPostEffect::setShaderConsts(%this)
{
   %this.setShaderConst("$BlurredVisionIntensity", $BlurredVisionIntensity);
}

// DREAM VIEW - working dx11
$DreamViewIntensity = 1.0;
singleton ShaderData( DreamViewShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/dreamviewP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( DreamViewPostEffect )  
{  
   isEnabled         = false;
   allowReflectPass  = false;
   //renderTime        = "PFXAfterBin";
   renderTime  = "PFXAfterDiffuse";//yorks
   //renderBin         = "GlowBin";//yorks this or ObjTranslucentBin below seem to work
   //renderBin = "ObjTranslucentBin";//yorks***
   shader            = DreamViewShader;
   stateBlock        = PFX_DefaultStateBlock;
   texture[0]        = "$backBuffer";
   renderPriority    = 10;
};

function DreamViewPostEffect::setShaderConsts(%this)
{
   %this.setShaderConst("$DreamViewIntensity", $DreamViewIntensity);
}

// CROSS STITCH - working in dx11
$CrossStichPostEffect::StitchingSize = 3.0;//yorks was 6
$CrossStichPostEffect::Invert = 1;//yorks was 0
singleton ShaderData( CrossStitchShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/crossStitchP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( CrossStitchPostEffect )  
{  
   isEnabled         = false;
   allowReflectPass  = false;
   //renderTime        = "PFXAfterBin";
   renderTime  = "PFXAfterDiffuse";//yorks
   //renderBin         = "GlowBin";//yorks 
   //renderBin = "ObjTranslucentBin";//yorks
   shader            = CrossStitchShader;
   stateBlock        = PFX_DefaultStateBlock;
   texture[0]        = "$backBuffer";
   renderPriority    = 10;
};

function CrossStitchPostEffect::setShaderConsts(%this)
{
   %this.setShaderConst( "$time", ($Sim::time - %this.timeStart) );
   %this.setShaderConst("$sizeX",getWord($pref::Video::mode, 0));
   %this.setShaderConst("$sizeY",getWord($pref::Video::mode, 1));
   %this.setShaderConst("$stitching_size", $CrossStichPostEffect::StitchingSize);
   %this.setShaderConst("$invert", $CrossStichPostEffect::Invert);
}

// POSTERISATION - working dx11 with some error complaints in console
$PosterisationPostEffect::Gamma     = 0.6;
$PosterisationPostEffect::NumColors = 4.0;
singleton ShaderData( PosterisationShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/posterisationP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( PosterisationPostEffect )  
{  
   isEnabled         = false;
   allowReflectPass  = false;
   //renderTime        = "PFXAfterBin";//yorks
   renderTime  = "PFXAfterDiffuse";//yorks
   //renderBin         = "GlowBin";//yorks this or ObjTranslucentBin below seem to work
   //renderBin = "ObjTranslucentBin";//yorks
   shader            = PosterisationShader;
   stateBlock        = PFX_DefaultStateBlock;
   texture[0]        = "$backBuffer";
   renderPriority    = 10;
};

function PosterisationPostEffect::setShaderConsts(%this)
{
   %this.setShaderConst("$gamma", $PosterisationPostEffect::Gamma);
   %this.setShaderConst("$numColors", $PosterisationPostEffect::NumColors);
}

// NIGHT VISION 2
$NightVisionPostEffect::LuminanceThreshold = 0.2;
$NightVisionPostEffect::ColorAmplification = 4.0;

singleton ShaderData( NightVision2Shader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/nightVision2P.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( NightVision2Fx )  
{  
   isEnabled         = false;
   allowReflectPass  = false;
   //renderTime        = "PFXAfterBin";
   renderTime  = "PFXAfterDiffuse";//yorks
   //renderBin         = "GlowBin";//yorks 
   //renderBin = "ObjTranslucentBin";//yorks
   shader            = NightVision2Shader;
   stateBlock        = PFX_DefaultStateBlock;
   texture[0]        = "$backBuffer";
   renderPriority    = 10;  
};

function NightVision2Fx::setShaderConsts(%this)
{
   %this.setShaderConst("$luminanceThreshold", $NightVisionPostEffect::LuminanceThreshold);
   %this.setShaderConst("$colorAmplification", $NightVisionPostEffect::ColorAmplification);
}

// LENS CIRCLE - works dx11
$LensCirclePostEffect::RadiusX = 0.6;
$LensCirclePostEffect::RadiusY = 0.2;

singleton ShaderData( LensCircleShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/lensCircleP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( LensCirclePostEffect )  
{  
   isEnabled         = false;
   allowReflectPass  = false;
   //renderTime        = "PFXAfterBin";
   renderTime  = "PFXAfterDiffuse";//yorks
   //renderBin         = "GlowBin";//yorks this or ObjTranslucentBin below seem to work 
   //renderBin = "ObjTranslucentBin";//yorks***
   shader            = LensCircleShader;
   stateBlock        = PFX_DefaultStateBlock;
   texture[0]        = "$backBuffer";
   renderPriority    = 10;
};

function LensCirclePostEffect::setShaderConsts(%this)
{
   %this.setShaderConst("$radiusX", $LensCirclePostEffect::RadiusX);
   %this.setShaderConst("$radiusY", $LensCirclePostEffect::RadiusY);
}

// CHROMATIC ABERRATION - working dx11
$ChromaticAberrationPostEffect::Intensity = 0.3;
singleton ShaderData( ChromaticAberrationShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/chromaticAberrationP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( ChromaticAberrationPostEffect )  
{  
   isEnabled         = false;
   allowReflectPass  = false;
   //renderTime        = "PFXAfterBin";
   renderTime  = "PFXAfterDiffuse";//yorks
   //renderBin         = "GlowBin";//yorks this or ObjTranslucentBin below seem to work
   //renderBin = "ObjTranslucentBin";//yorks***
   shader            = ChromaticAberrationShader;
   stateBlock        = PFX_DefaultStateBlock;
   texture[0]        = "$backBuffer";
   renderPriority    = 10;
};

function ChromaticAberrationPostEffect::setShaderConsts(%this)
{
   %this.setShaderConst("$intensity", $ChromaticAberrationPostEffect::Intensity);
}

// RGB - working dx11
$RGBPostEffect::RedLevel   = 1.0;
$RGBPostEffect::GreenLevel = 1.0;
$RGBPostEffect::BlueLevel  = 1.0;
singleton ShaderData( RGBShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/rgbP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( RGBPostEffect )  
{  
   isEnabled         = false;
   allowReflectPass  = false;
   //renderTime        = "PFXAfterBin";
   renderTime  = "PFXAfterDiffuse";//yorks
   //renderBin         = "GlowBin";//yorks this or ObjTranslucentBin below seem to work
   //renderBin = "ObjTranslucentBin";//yorks
   shader            = RGBShader;
   stateBlock        = PFX_DefaultStateBlock;
   texture[0]        = "$backBuffer";
   renderPriority    = 10;
};

function RGBPostEffect::setShaderConsts(%this)
{
   %this.setShaderConst("$redLevel", $RGBPostEffect::RedLevel);
   %this.setShaderConst("$greenLevel", $RGBPostEffect::GreenLevel);
   %this.setShaderConst("$blueLevel", $RGBPostEffect::BlueLevel);
}

// ZOOM BLUR - yorks working dx11
$ZoomBlur::Amount  = 0.99;
$ZoomBlur::Samples = 3;//6;//yorks

singleton ShaderData( ZoomBlurShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/zoomBlurP.hlsl";
   samplerNames[0]      = "$inputTex";
   samplerNames[1] = "$backBuffer";//yorks
   pixVersion           = 3.0;
};

singleton PostEffect( ZoomBlurPostEffect )  
{  
   renderTime  = "PFXAfterDiffuse";
   shader      = ZoomBlurShader;
   stateBlock  = PFX_DefaultStateBlock;
   texture[0]  = "$backBuffer";
};

function ZoomBlurPostEffect::setShaderConsts(%this)
{
   %this.setShaderConst("$amount", $ZoomBlur::Amount);
   %this.setShaderConst("$samples", $ZoomBlur::Samples);
}

// NEGATIVE - working dx11
singleton ShaderData( NegativeShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/negativeP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( NegativePostEffect )  
{  
   renderTime  = "PFXAfterDiffuse";
   //renderBin = "GlowBin";
   //renderPriority = 0.5; // Render after the glows themselves
   
   shader      = NegativeShader;
   stateBlock  = PFX_DefaultStateBlock;
   texture[0]  = "$backBuffer";
};

// BLACK AND WHITE - working dx11
singleton ShaderData( BlackAndWhiteShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/blackAndWhiteP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( BlackAndWhitePostEffect )  
{  
   renderTime  = "PFXAfterDiffuse";
   shader      = BlackAndWhiteShader;
   stateBlock  = PFX_DefaultStateBlock;
   texture[0]  = "$backBuffer";//yorks
};

// MONOCHROME - working dx11
singleton ShaderData( MonochromeShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/monochromeP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( MonochromePostEffect )  
{  
   renderTime  = "PFXAfterDiffuse";
   shader      = MonochromeShader;
   stateBlock  = PFX_DefaultStateBlock;
   texture[0]  = "$backBuffer";
};

// EDGE DETECTION - working dx11
$EdgeDetection::Threshold = 0.01;

singleton ShaderData( EdgeDetectionShader )
{   
   DXVertexShaderFile 	= "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile 	= "shaders/common/postFx/Library/edgeDetectionP.hlsl";
   samplerNames[0] = "$backBuffer";//yorks
   pixVersion = 2.0;
};

singleton PostEffect( EdgeDetectionPostEffect )  
{  
   renderTime  = "PFXAfterDiffuse";
   shader      = EdgeDetectionShader;
   stateBlock  = PFX_DefaultStateBlock;
   texture[0]  = "$backBuffer";
};

function EdgeDetectionPostEffect::setShaderConsts(%this)
{
   %this.setShaderConst("$threshold", $EdgeDetection::Threshold);
}